// Ptp_to_up.cpp: implementation of the Ptp_to_up class.
//
//////////////////////////////////////////////////////////////////////

#include "Ptp_to_up.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Ptp_to_up :: Ptp_to_up ( )
{
//
  time(&t1);  flError=0;  SUMErr=0;
  system_tolerance=0.0000005;
//

	SUMX=0;SUMY=0;SUMZ=0;
	k=1; /*   */
	f=0; /*    curr */
	mode=0; /*  */
	SPEED_LIMIT=50;    /*        (/)*/
	FEED_MAX=1200;     /*       (/)*/
	a=5;            /*  (  *) */
	acenter=5;        /*   */
	PLANE=17; /*    */
	flag=0;

//
   char *path, *ptr;
   /* get the current path environment */
   ptr = getenv(strTemp);
   /* set up new path */
   path = (char *) malloc(strlen(ptr)+15);
   strcpy(path,ptr);
   strcat(path,strLog);
   log_file=fopen(path,"a");
   if (log_file==NULL) { puts("Can't append log file"); }
   issueError (0,"\n\n#Start of decode file \n#Date\\Time: %s",ctime(&t1));
   issueError (0,"#ENV(TEMP)= %s \n#PATH= %s\n",ptr,path);
   issueError (0,"#!!!!For best view set font = 'Lucida Console'\n");
//

}

Ptp_to_up :: ~Ptp_to_up ( )
{
	if (log_file!=NULL)
	{ time(&t1);
	  //sprintf(mes,"  -> \n%f  = %f ",TIME,TIME/60);
	  issueError (0,"\n#   := %d \n",SUMErr);
	  issueError (0,"\n# SUMX= %ld \n# SUMY= %ld \n# SUMZ= %ld \n",SUMX,SUMY,SUMZ);
	  issueError (0,"\n#End of decode file: %s \n",ctime(&t1));
	  fclose(log_file);
	}

}


/*     */
/*
void put_kadr(char kadr[70])
{ char *str,word[50],*kadr1;
  if(read_word(kadr,'N',word))  {
  	sprintf(str,"%3.3d",k);
  	*(kadr+1)=*str;*(kadr+2)=*(str+1);*(kadr+3)=*(str+2);
  	k=k+1; if(k==1000) k=1;
  }
  fputs(kadr,out);
} */


/* This function read the numeric string after key letter in success it return 1, otherwice 0 */
int Ptp_to_up ::  read_word(char *s,char w,char *sw)
{   char *word,sym;
	 int  n;
	 if(s==NULL) return(0);
	 if ((word=strchr(s,w))==NULL) return(0);
	 n=0;
	 do
	 {  sym=*(word+(n+1));
		 if (isdigit(sym)||sym==' '||sym=='+'||sym=='-'||sym=='.') n++;
		 else break;
	 } while (1);
	 if (n>0){ strncpy(sw,word+1,n); sw[n]='\0'; return(n); }
	 else                                        return(0);
}

/* This function replace the numeric string after key letter
	if there isn't a key letter in a string funktion adds it at the end of a string */

void Ptp_to_up :: replace_word(char *s,char w,char *sw)
{
  int n;
  char old_sw[20],save[100],*p;

  if ((n=read_word(s,w,old_sw))!=0)
  {
	 /* replace word */
	 p=strchr(s,w);
	 *(p+1)='\0'; strcpy(save,p+n+1);
	 strcat(strcat(s,sw),save);
  }
  else
  {
	 /* add word at the end of string */
       if(n=read_word(s,'L',old_sw)==0)
        {
			p=strchr(s,'<') ; /* string have <CR> or <LF> as text */
	 if (p==NULL)   p=strchr(s,'\r'); /* string have \r\n */
	 if (p==NULL)   p=strchr(s,'\n'); /* string have \n   */
	 if (p!=NULL)
	 { strcpy(save,p); *p=w; *(p+1)='\0'; strcat(strcat(s,sw),save); }
	 else
	 {
		save[0]=w; save[1]='\n'; save[2]='\0'; strcat(strcat(s,save),sw); }
        }
       else
        {
        p=strchr(s,'L'); *p=w;
	*(p+1)='\0'; strcpy(save,p+n+1);
	strcat(strcat(s,sw),save);
        strcat(strcat(s,"L"),strcat(old_sw,"\n"));
        }

  }
}


/*  This function code the feed value for N33 numeric control */
void Ptp_to_up ::  feed_convert(int f,int mode,char *new_feed)
{ int k;
if(f>0)
  {
  k=(int)log10((float)f);
  if(k==1) f=f;
  else if(k==0) f=f*10;
  else if(k>=1 && k<=2) f=f/10;
  else if(k>2 && k<=3) f=f/100;
  sprintf(new_feed,"%1d%1d%2.2d",mode, k+4, f);
  k=0;
  }
  else strcpy(new_feed,"0000");
}


/*       curr  next.
	 curr       "" P */

void Ptp_to_up ::  analiz(char *curr,char *next)
{
 double	x,xn,y,yn,z,zn,I,In,J,Jn,K,Kn,CosA,FA;
  int	f1,fn,move,new_move,feed_set,new_feed_set,old_f;
  char  new_feed[10],str[20];
  char	word_x[50],word_y[50],word_z[50],word_f[50];
  int error;
  int IJKcurr=0;  /*  */
  int IJKnext=0;

if(strstr(curr,"G02")!=NULL) G=2;
else if(strstr(curr,"G03")!=NULL) G=3;

if(strstr(curr,"G17")!=NULL) PLANE=17;
else if(strstr(curr,"G18")!=NULL)  PLANE=18;
		  else if(strstr(curr,"G19")!=NULL) PLANE=19;

move=new_move=feed_set=new_feed_set=0;
	  if (read_word(curr,'X',word_x)) { sscanf(word_x,"%f",&x);x=x/100;
						 SUMX=SUMX+x;
						 move=1; }  else x=0.0;
	  if (read_word(curr,'Y',word_y)) { sscanf(word_y,"%f",&y);y=y/100;
						 SUMY=SUMY+y;
						 move=1; }  else y=0.0;
	  if (read_word(curr,'Z',word_z)) { sscanf(word_z,"%f",&z);z=z/100;
						 SUMZ=SUMZ+z;
						 move=1; }  else z=0.0;
if(move==1){
 if (read_word(curr,'I',word_z))  {sscanf(word_z,"%f",&I);I=I/100;IJKcurr=1;}  else I=0.0;
 if (read_word(curr,'J',word_z))  {sscanf(word_z,"%f",&J);J=J/100;IJKcurr=1;}  else J=0.0;
 if (read_word(curr,'K',word_z))  {sscanf(word_z,"%f",&K);K=K/100;IJKcurr=1;}  else K=0.0;
}
	if (read_word(curr,'F',word_f))
	{ sscanf(word_f,"%d",&f);
	  if((i==0) && (f>FEED_MAX))
	  {
	     f=FEED_MAX;
	     sprintf(new_feed,"%d",f);
	     replace_word(curr,'F',new_feed);
	    }
	   feed_set=1;
	}
/*      ,     */
if( move==1 && (sqrt(x*x+y*y+z*z) <= 0.21) && (f>SPEED_LIMIT*2) )
  {
  old_f=f;
  f=SPEED_LIMIT*2;
  sprintf(new_feed,"%d",f);
  replace_word(curr,'F',new_feed);
  flag=1; feed_set=1;
  }

/*     
	   curr */
if(move==1 && mode>0 && feed_set==0)
  if(flag==0) feed_set=1;
  else {/*****************************/
       sprintf(new_feed,"%d",old_f);
       replace_word(curr,'F',new_feed);
       feed_set=1;
       f=old_f;
       flag=0;
       }/*****************************/

/*  curr    */
 strcpy(P[i].kadr,curr);
 if (feed_set==1) P[i].feed=f;
  else if (i==0) P[i].feed=0;
      else if(move==1) P[i].feed=f;
 if (move==1) P[i].span=sqrt(x*x+y*y+z*z);else P[i].span=0;
 error=otkat(i); /*  ,            curr */
 if(error) exit(0);
 mode=0;
label:
		if (read_word(next,'X',word_x)) { new_move=1; sscanf(word_x,"%f",&xn); xn=xn/100;} else xn=0.0;
		if (read_word(next,'Y',word_y)) { new_move=1; sscanf(word_y,"%f",&yn); yn=yn/100;} else yn=0.0;
		if (read_word(next,'Z',word_z)) { new_move=1; sscanf(word_z,"%f",&zn); zn=zn/100;} else zn=0.0;
if(new_move==1){
 if (read_word(next,'I',word_z))  {sscanf(word_z,"%f",&In);In=In/100;IJKnext=1;}	  else In=0.0;
 if (read_word(next,'J',word_z))  {sscanf(word_z,"%f",&Jn);Jn=Jn/100;IJKnext=1;}	  else Jn=0.0;
 if (read_word(next,'K',word_z))  {sscanf(word_z,"%f",&Kn);Kn=Kn/100;IJKnext=1;}	  else Kn=0.0;
 }
		if (read_word(next,'F',word_f))	 {
			new_feed_set=1;
			sscanf(word_f,"%d",&fn);
			if(fn>FEED_MAX)
			{
				fn=FEED_MAX;
				sprintf(new_feed,"%d",fn);
				replace_word(next,'F',new_feed);
			}
		 } else {new_feed_set=0; fn=f;}
/*    curr       
          next */
if(flag==1 && new_feed_set==0 && new_move==1)
  {
  sprintf(new_feed,"%d",old_f);
  replace_word(next,'F',new_feed);
  new_feed_set=1;
  fn=old_f;
  flag=0;
  }
else if(flag==1 && new_move==1) flag=0;

/*    next   ,    */
if( move==1 && new_move==0 && new_feed_set==1 )
  { if(read_word(next,'M',word_x) ||
		 read_word(next,'L',word_x) ||
		 	read_word(next,'G',word_x))
		 		{ feed_del(next); new_feed_set=0; }

	 else{
	 next=fgets(s_next,199,input);
	 if(next==NULL) strcpy(s_next,"END");
	 new_feed_set=0;
	 goto label;
	}
  }

/*    */

if(IJKnext){FA=sqrt(acenter*(In*In+Jn*Jn+Kn*Kn))*60; /* FA -        */
				 if(FA<fn) {fn=(int)FA;
				            sprintf(new_feed,"%d",fn);
            				    replace_word(next,'F',new_feed);
					    new_feed_set=1;
					   }
				}
/*************************************************/
/*       
        ,   > 100 */
if(IJKcurr && (f>fn) && (sqrt(x*x+y*y+z*z)<100)){
			 f=fn; P[i].feed=f;
			 feed_convert(f,0,new_feed);
			 replace_word(P[i].kadr,'F',new_feed);
			 error=otkat(i);
			 if(error) exit(0);
			 }
/*************************************************/
		if (move==1)
		{

		if (new_move)
		{
	if (fn > SPEED_LIMIT )
		 {
/*        
						   */
if(IJKcurr){
	if(PLANE==17)	tangent(I+x,J+y,&x,&y);
	else if(PLANE==18)	tangent(I+x,K+z,&x,&z);
	  else if(PLANE==19)	tangent(J+y,K+z,&y,&z);
	/* {x,y,z} -        */
	  }

if(IJKnext){
	if(strstr(next,"G02")!=NULL) G=2;
	else if(strstr(next,"G03")!=NULL) G=3;
	if(PLANE==17)	tangent(In,Jn,&xn,&yn);
	else if(PLANE==18)	tangent(In,Kn,&xn,&zn);
  else if(PLANE==19)	tangent(Jn,Kn,&yn,&zn);
	 /* {x,y,z} -        */
		}

 /*       {x,y,z}  {xn,yn,zn} */
 CosA=(x*xn+y*yn+z*zn)/sqrt(x*x+y*y+z*z)/sqrt(xn*xn+yn*yn+zn*zn);
		 if( CosA!=1 )
		  {
		  /*       */
		  if(SPEED_LIMIT==0)if(CosA==-1)FA=0;	else        FA=2/(1-CosA);
  		  else FA=SPEED_LIMIT*2/(1-CosA);
		  /*      
		,   mode=1 */
		  if ( (FA < fn) && ( FA < f ) ) mode=1;
		  }


		 }
		}
		else  /* new_move==0  */
		 /*      
			  ,   mode=2 */
		 if(new_feed_set==0)
		 mode=2;

	  } /* end of if(move==1) */

/*     next   
	  analiz    ,
	   mode=3 */
	  if(move==0 && new_move==1 && new_feed_set==0)  mode=3;

/*        */
	  if (feed_set)
	  {
	  if(f ) { feed_convert(f,0,new_feed);
			replace_word(P[i].kadr,'F',new_feed);
				}
		 else  replace_word(P[i].kadr,'F',"0000");
	  }


/*         FA */
	  if(mode==1){ f1=(int)FA;
		  feed_convert(f1,0,new_feed);
		  strcpy(str,"N000F");
		  strcat(str,strcat(new_feed,"\n"));
/*************************************************/
/*       
        ,
    > 100 */
if (read_word(curr,'X',word_x)) { sscanf(word_x,"%f",&x);x=x/100; } else x=0.0;
if (read_word(curr,'Y',word_y)) { sscanf(word_y,"%f",&y);y=y/100; } else y=0.0;
if (read_word(curr,'Z',word_z)) { sscanf(word_z,"%f",&z);z=z/100; } else z=0.0;
			 if(IJKcurr && (sqrt(x*x+y*y+z*z)<100)) {
				 P[i].feed=f1;
				 feed_convert(f1,0,new_feed);
				 replace_word(P[i].kadr,'F',new_feed);
				 }
			 else    {
/*************************************************/
		  i=i+1;
		  strcpy(P[i].kadr,str);
		  P[i].feed=f1;
		  P[i].span=0;
		  /*       */
		 }
		  error=otkat(i);
		  if(error) exit(0);
		}

/*         */
	  if(mode==2) {i=i+1;
		  strcpy(P[i].kadr,"N000F0000\n");
		  P[i].feed=0;
		  P[i].span=0;
		  /*       */
		  error=otkat(i);
		  if(error) exit(0);
		  mode=0;}

}

/*      
	 .    
	     ,  
	    ,  -
	         */

int Ptp_to_up ::  otkat(int j)
{
double f,x,y,z;
int f1,jj;
char new_feed[10];
char word[50],word_x[50],word_y[50],word_z[50];

if(j==0) return 0;
jj=j;
 while((j>0) && (P[j].feed<P[j-1].feed))
	  {
	  /**********************************/
	   if (read_word(P[j-1].kadr,'X',word_x)) { sscanf(word_x,"%f",&x);x=x/100; } else x=0.0;
	   if (read_word(P[j-1].kadr,'Y',word_y)) { sscanf(word_y,"%f",&y);y=y/100; } else y=0.0;
	   if (read_word(P[j-1].kadr,'Z',word_z)) { sscanf(word_z,"%f",&z);z=z/100; } else z=0.0;
	  if((read_word(P[j-1].kadr,'I',word)||read_word(P[j-1].kadr,'J',word)||
	read_word(P[j-1].kadr,'K',word)) && (sqrt(x*x+y*y+z*z)<100))
	  {
	  if(P[j].feed==0){
	  	  issueError (-11,"\n  c   %s\n    0.   .\n\n",P[j-1].kadr) ;
	  	  return 1;
	  	 }
	  P[j-1].feed=P[j].feed;
	  feed_convert(P[j].feed,0,new_feed);
	  replace_word(P[j-1].kadr,'F',new_feed);
	  j--; continue;
	  }
	  /**********************************/
	 f=sqrt(2*a*P[j-1].span+(float)P[j].feed*(float)P[j].feed/60/60);
	 f1=(int)f*60; /*    / */
	 if(f1==0) f1=5;
	 if( f1 < P[j-1].feed )
	 { P[j-1].feed = f1;
		feed_convert(f1,0,new_feed);
			replace_word(P[j-1].kadr,'F',new_feed);
		j--;
			}
	  else break;
	  }
if(j==0) {
	 issueError(-11,"\n C    :\n %s %s \n       18- .\n\n   .",P[jj-1].kadr,P[jj].kadr);
	 return 1;
	 }
else return 0;
}

/*       */
void Ptp_to_up :: feed_del(char *kadr)
{
	char ch;
	char str[20];
	int i=0,j=0;
	ch=*kadr;
	do
	{
	 ch=*(kadr+j);
	 if(ch=='F') {j=j+5;continue;}
	 str[i++]=ch;
	 j++;
	} while(ch!='\0');
 	strcpy(kadr,str);
}

/*   {x,y}  ,   x,y,i,j,    */
void Ptp_to_up :: tangent(double i,double j,double *x,double *y)
{
if(i==0 || j==0)
{/*****/
if((*x>0) && (*y<0) && (G==2))
  {*x=0; *y=-1;}
else if((*x<0) && (*y>0) && (G==3))
       {*x=-1; *y=0;}
     else if((*x>0) && (*y>0) && (G==2))
	    {*x=1; *y=0;}
	  else if((*x<0) && (*y<0) && (G==3))
		 {*x=0; *y=-1;}
	       else if((*x<0) && (*y>0) && (G==2))
		      {*x=0; *y=1;}
		    else if((*x>0) && (*y<0) && (G==3))
			   {*x=1; *y=0;}
			 else if((*x<0) && (*y<0) && (G==2))
				{*x=-1; *y=0;}
			      else if((*x>0) && (*y>0) && (G==3))
				     {*x=0; *y=1;}
return;
}/*****/

/*    ,   .. */
if((*x>0) && (*y<0) && (G==2))
  {*x=fabs(j); *y=-fabs(i);}
/*    ,   .. */
else if((*x<0) && (*y>0) && (G==3))
			{*x=-fabs(j); *y=fabs(i);}
/*    ,   .. */
	  else if((*x>0) && (*y>0) && (G==2))
		{*x=fabs(j); *y=fabs(i);}
/*    ,   .. */
		 else if((*x<0) && (*y<0) && (G==3))
			{*x=-fabs(j); *y=-fabs(i);}
/*    ,   .c. */
			else if((*x<0) && (*y>0) && (G==2))
			 {*x=-fabs(j); *y=fabs(i);}
/*    ,   .. */
			  else if((*x>0) && (*y<0) && (G==3))
				{*x=fabs(j); *y=-fabs(i);}
/*    ,   .c. */
				 else if((*x<0) && (*y<0) && (G==2))  {*x=-fabs(j); *y=-fabs(i);}
/*    ,   .. */
					else if((*x>0) && (*y>0)&& (G==3)) {*x=fabs(j); *y=fabs(i);}
}


int Ptp_to_up :: issueError (int ecode, char *format, ... )
{
   va_list   ap;  char  bufStr[133];bufStr[0]='\0';
   va_start( ap, format );
   if( ecode != 0 )
   {
     SUMErr++;
     if (log_file!=NULL) {
     	//fprintf( log_file, "Error %d: %s\n", ecode, bufStr );
     	switch(ecode)
	{
	case -1: break;
	case -11: break;
	case -21:
         break;
	default: break;
	}
      }
   }
   //vfprintf( log_file, format, ap );
   va_end( ap );
   return(0);
}


int Ptp_to_up :: main_Ptp_to_up(void)
{
  int ii;
  char str[10],word[50];
  char mes[300];
	/* scaning input file */

	curr=fgets(s_curr,199,input); next=fgets(s_next,199,input);
	i=-1;
	while (curr!=NULL)
	{
	i=i+1;
	analiz(curr,next);
	/* 18-  19-            analiz */
	if(i==18)
	{
if(read_word(P[0].kadr,'N',word))
  {
  sprintf(str,"%3.3d",k);
  *(P[0].kadr+1)=*str;*(P[0].kadr+2)=*(str+1);*(P[0].kadr+3)=*(str+2);
  k=k+1; if(k==1000) k=1;
  }
fputs(P[0].kadr,out);

		 for(i=0;i<=17;i++)
		 {
		 strcpy(P[i].kadr,P[i+1].kadr);
		 P[i].feed=P[i+1].feed;
		 P[i].span=P[i+1].span;
		 }
		 i=17;
		 } /* end of if(i==18) */
	  if(i==19)
		 {
if(read_word(P[0].kadr,'N',word))
  {
  sprintf(str,"%3.3d",k);
  *(P[0].kadr+1)=*str;*(P[0].kadr+2)=*(str+1);*(P[0].kadr+3)=*(str+2);
  k=k+1; if(k==1000) k=1;
  }
fputs(P[0].kadr,out);

if(read_word(P[1].kadr,'N',word))
  {
  sprintf(str,"%3.3d",k);
  *(P[1].kadr+1)=*str;*(P[1].kadr+2)=*(str+1);*(P[1].kadr+3)=*(str+2);
  k=k+1; if(k==1000) k=1;
  }
fputs(P[1].kadr,out);

		 for(i=0;i<=17;i++)
		 {
		 strcpy(P[i].kadr,P[i+2].kadr);
		 P[i].feed=P[i+2].feed;
		 P[i].span=P[i+2].span;
		 }
		 i=17;
		 } /* end of if(i==19) */

	  if ((next!=NULL) && (strcmp(s_next,"END")!=0)) strcpy(curr,next);
	  else curr=NULL;
	  next=fgets(s_next,199,input);
	} /* end of while */

/*          */
 for(ii=0;ii<=i;ii++)
{
if(read_word(P[ii].kadr,'N',word))
  {
  sprintf(str,"%3.3d",k);
  *(P[ii].kadr+1)=*str;*(P[ii].kadr+2)=*(str+1);*(P[ii].kadr+3)=*(str+2);
  k=k+1; if(k==1000) k=1;
  }
fputs(P[ii].kadr,out);
}


/*   */
  sprintf(mes,"  \n :\n\n SUMX =%10.2f mm\nSUMY =%10.2f mm\nSUMZ =%10.2f mm\n",SUMX,SUMY,SUMZ);

  return 0;
}

